Index: cpp/frams/canvas/neurodiagram.cpp
===================================================================
--- cpp/frams/canvas/neurodiagram.cpp	(revision 348)
+++ cpp/frams/canvas/neurodiagram.cpp	(revision 718)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2017  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -69,6 +69,6 @@
 
 NeuroDiagram::NeuroDiagram(ColorDefs *cd)
-:FramDrawToolkit(cd), livewire(false), indestructor(false), showing_not_alive_label(false), o(0),
-warn_if_not_alive(true), selection(*this), drawbackground(true), linetype(true), layouttype(2)
+	:FramDrawToolkit(cd), livewire(false), indestructor(false), showing_not_alive_label(false), o(0),
+	warn_if_not_alive(true), selection(*this), drawbackground(true), linetype(true), layouttype(2)
 {
 	scroll.setMargin(10, 10); // appropriate size should be adjusted
@@ -91,5 +91,5 @@
 	showing_not_alive_label = 0;
 	if (o) o->delmodel_list.remove(killnode);
-	FOREACH(NeuroProbe*,pr,probes)
+	FOREACH(NeuroProbe*, pr, probes)
 		delete pr;
 	probes.clear();
@@ -244,5 +244,5 @@
 
 NeuroSymbol::NeuroSymbol(NeuroDiagram &nd, Neuro * _n)
-	:selected(0), n(_n), diagram(nd), FramDrawToolkit(nd.getColorDefs())
+	:FramDrawToolkit(nd.getColorDefs()), selected(0), n(_n), diagram(nd)
 {
 	tooltip = "#";
@@ -287,32 +287,32 @@
 	}
 
-/*
-
-            NeuroDiagram
-            *........................................
-            .                                       .
-            .                    NeuroSymbol        .
-            .      (pos.x,pos.y)-*.........         .
-            .                    . |\     . ^  s    .
-            .            ..._____._| \    . |  i    . 
-            .                    . |  \___. |  z    . 
-            .                  __._|  /   . |  e    . 
-            .                 |  . | /    . |  .    . 
-            .                 |  . |/     . |  y    .  
-            .                 |  .......... v       .  
-            .                 |  <-------->         .  
-            .      .......... |    size.x           .
-            .      . |\     . |                     .
-            .    __._| \    . |                     .
-            .      . |  \___._|                     .
-            .    __._|  /   .                       .
-            .   |  . | /    .                       .
-            .   |  . |/     .                       .
-            .   |  ..........                       .
-            .   |                                   .
-            .   |________________...                .
-            .........................................
-
- */
+	/*
+
+				NeuroDiagram
+				*........................................
+				.                                       .
+				.                    NeuroSymbol        .
+				.      (pos.x,pos.y)-*.........         .
+				.                    . |\     . ^  s    .
+				.            ..._____._| \    . |  i    .
+				.                    . |  \___. |  z    .
+				.                  __._|  /   . |  e    .
+				.                 |  . | /    . |  .    .
+				.                 |  . |/     . |  y    .
+				.                 |  .......... v       .
+				.                 |  <-------->         .
+				.      .......... |    size.x           .
+				.      . |\     . |                     .
+				.    __._| \    . |                     .
+				.      . |  \___._|                     .
+				.    __._|  /   .                       .
+				.   |  . | /    .                       .
+				.   |  . |/     .                       .
+				.   |  ..........                       .
+				.   |                                   .
+				.   |________________...                .
+				.........................................
+
+				*/
 
 	// NeuroSymbol is also responsible for drawing connection lines from its inputs to other NeuroSymbols' outputs
@@ -416,26 +416,26 @@
 {
 	if ((y >= 0) && (y < size.y))
-		if (x<size.x / 4)
+		if (x < size.x / 4)
 		{ // inputs?
-			if (n->getInputCount()>0)
+		if (n->getInputCount() > 0)
+		{
+			int i = (y*n->getInputCount()) / size.y;
+			double w;
+			Neuro* target = n->getInput(i, w);
+			if (target)
 			{
-				int i = (y*n->getInputCount()) / size.y;
-				double w;
-				Neuro* target = n->getInput(i, w);
-				if (target)
+				SString t = "connected to #";
+				t += SString::valueOf((int)target->refno);
+				t += " - ";
+				addNeuroDescription(t, target);
+				//		if (w!=1.0)
 				{
-					SString t = "connected to #";
-					t += SString::valueOf((int)target->refno);
-					t += " - ";
-					addNeuroDescription(t, target);
-					//		if (w!=1.0)
-					{
-						t += ", weight=";
-						t += SString::valueOf(w);
-					}
-					return t;
+					t += ", weight=";
+					t += SString::valueOf(w);
 				}
+				return t;
 			}
 		}
+		}
 	return CanvasWindow::hint(x, y);
 }
@@ -444,6 +444,6 @@
 
 NeuroProbe::NeuroProbe(NeuroSymbol* ns)
-:DCanvasWindow(DCanvasWindow::Title + DCanvasWindow::Border + DCanvasWindow::Close + DCanvasWindow::Size,
-  ns->getLabel().c_str(), &neurochart, &neurochart)
+	:DCanvasWindow(DCanvasWindow::Title + DCanvasWindow::Border + DCanvasWindow::Close + DCanvasWindow::Size,
+	ns->getLabel().c_str(), &neurochart, &neurochart)
 {
 	holdismine = 0;
@@ -683,5 +683,5 @@
 void NeuroDiagram::probeSampling(void*obj, intptr_t dummy)
 {
-	FOREACH(NeuroProbe*,pr,probes) pr->sampling();
+	FOREACH(NeuroProbe*, pr, probes) pr->sampling();
 	requestPaint();
 }